=== debian/control ===
Source: ros-melodic-mpc-local-planner
Section: misc
Priority: optional
Maintainer: Christoph Rösmann <christoph.roesmann@tu-dortmund.de>
Build-Depends: debhelper (>= 9.0.0), libeigen3-dev, ros-melodic-base-local-planner, ros-melodic-catkin, ros-melodic-control-box-rst, ros-melodic-costmap-2d, ros-melodic-costmap-converter, ros-melodic-dynamic-reconfigure, ros-melodic-geometry-msgs, ros-melodic-interactive-markers, ros-melodic-mbf-costmap-core, ros-melodic-mbf-msgs, ros-melodic-mpc-local-planner-msgs, ros-melodic-nav-core, ros-melodic-nav-msgs, ros-melodic-pluginlib, ros-melodic-roscpp, ros-melodic-std-msgs, ros-melodic-teb-local-planner, ros-melodic-tf2, ros-melodic-tf2-eigen, ros-melodic-tf2-geometry-msgs, ros-melodic-tf2-ros, ros-melodic-visualization-msgs
Homepage: http://wiki.ros.org/mpc_local_planner
Standards-Version: 3.9.2

Package: ros-melodic-mpc-local-planner
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libeigen3-dev, ros-melodic-base-local-planner, ros-melodic-control-box-rst, ros-melodic-costmap-2d, ros-melodic-costmap-converter, ros-melodic-dynamic-reconfigure, ros-melodic-geometry-msgs, ros-melodic-interactive-markers, ros-melodic-mbf-costmap-core, ros-melodic-mbf-msgs, ros-melodic-mpc-local-planner-msgs, ros-melodic-nav-core, ros-melodic-nav-msgs, ros-melodic-pluginlib, ros-melodic-roscpp, ros-melodic-std-msgs, ros-melodic-teb-local-planner, ros-melodic-tf2, ros-melodic-tf2-ros, ros-melodic-visualization-msgs
Description: The mpc_local_planner package implements a plugin to the base_local_planner of the 2D navigation stack.
 It provides a generic and versatile model predictive control implementation with minimum-time and quadratic-form receding-horizon configurations.
